//package code2001b;

//import code2001b.Sommet;

/**
 * @version 1.0
 */

//-------------------------------------------------//
//                                                 //
//                CLASSE ARC                       //
//                                                 //
//-------------------------------------------------//
 
public class Arc {

  //Caracteristik de base d'un arc
  private Sommet initial;
  private Sommet terminal;
  private int capacite;
  private int flot;
  private int etat;

  //------------------------------
  // Etats de l'arc ...
  //
  // 0 : Rien
  // 1 : En cours
  // 2 : Arc ameliorant ...
  //
  //------------------------------

     
  //---------------------------------------------------
  // Constructeur:
  // C dans le nom ...
  //---------------------------------------------------

  public Arc(Sommet init, Sommet term, int capa) {
    initial = init ;
    terminal = term ;
    flot = 0;
    capacite = capa;
    term.ajouterEntrant(this);
    init.ajouterSortant(this);
    etat=0;
 
  }
  
  // Procedure de gestion des attributs

  //---------------------------------------------------
  // Fonction getInitial()(respectivement getTerminal()):
  // Permet de recuperer le sommet Initial (respectivement Terminal) de l'Arc
  //---------------------------------------------------

  public Sommet getInitial() {    
    return initial;
  }

  public Sommet getTerminal() {
    return terminal;
  }

  //---------------------------------------------------
  // Fonction getCapacite():
  // Permet de recuperer la capacite de l'Arc
  //---------------------------------------------------
  
  public int getCapacite() {
    return capacite;
  }

  //---------------------------------------------------
  // Fonction augmenterFlot()(respectivement diminuerFlot()):
  // Permet d'augmenter(respectivement diminuer) le flot de l'Arc
  //---------------------------------------------------
 
  public void augmenterFlot(int a) {
    flot+=a;
  }

  public void diminuerFlot(int a) {
    flot-=a;
  }

  //---------------------------------------------------
  // Fonction getFlot():
  // Permet de recuperer le flot de l'Arc
  //---------------------------------------------------
   
  public int getFlot() {
    return flot;
  }

    public void setFlot(int a){
	flot=a;
    }


  //---------------------------------------------------
  // Fonction setEtat(), getEtat():
  // Permet de manipuler l'etat de l'Arc
  //---------------------------------------------------
 	
  public void setEtat(int a) {
    etat=a;
  }

  public int getEtat() {
    return etat;
  }

  //---------------------------------------------------
  // Fonction deleteArc():
  // Permet de supprimer l'Arc
  //---------------------------------------------------

  public void deleteArc() throws Throwable {
    terminal.enleverEntrant(this);
    initial.enleverSortant(this);
    this.finalize();
  }
}

