import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.LinkedList;
import java.util.List;
import java.io.*;




public class FenEditeur extends JInternalFrame implements ActionListener {
    
    // Barre des menus
    JMenuBar menuBarEditeur = new JMenuBar();
    
    // Les menus
    /*JMenu menuFichier = new JMenu("Fichier"); // Fichier*/
    JMenu menuOutils = new JMenu("Outils");   // Outils (arcs, sommets)
    JMenu menuAide = new JMenu("?");          // Menu d'aide
    
    // Les actions des menus
    /* JMenuItem enregistrer   = new JMenuItem("Enregistrer"   );
       JMenuItem quitter       = new JMenuItem("Quitter"       );
    */
    JMenuItem nouveauSommet = new JMenuItem("Nouveau Sommet");
    JMenuItem nouveauArc    = new JMenuItem("Nouvel Arc"    );
    JMenuItem supprimer     = new JMenuItem("Supprimer Sommet"  );
    JMenuItem pas           = new JMenuItem("Changer le pas du magnetisme");
    JMenuItem specSource    = new JMenuItem("Indiquer la source");
    JMenuItem specPuit      = new JMenuItem("Indiquer le puit");
    
    JMenuItem aide          = new JMenuItem("Aide"          );
    JMenuItem aPropos       = new JMenuItem("A propos"      );
    
    // Le Graphe dit
    private Graphe graphe;
    private FenConEditeur contenu;
    
    
    
    // ----------------------------------------
    // Le constructeur quand on ouvre un graphe
    // ----------------------------------------
    public FenEditeur(Graphe gra)  {
	super("Editeur", 
	      true, //resizable
	      false, //closable
	      true, //maximizable
	      false);//iconifiable
	
	graphe = gra;
	dessinerMenu();
	setSize(740,480);
	setLocation(0,0);
	
	
	
	
	contenu = new FenConEditeur(graphe);
	this.getContentPane().add(contenu, "Center");
	contenu.repaint();
	setVisible(true);
	setResizable(true);
	
	
    }
    
    // ----------------
    // dessin des menus
    // ----------------
    void dessinerMenu() {
	
	// Ajout des lments des menus
	/* menuFichier.add(enregistrer);
	   menuFichier.add(quitter    );
	*/
	menuOutils.add(nouveauSommet   );
	menuOutils.add(nouveauArc      );
	menuOutils.add(supprimer       );
	menuOutils.add(new JSeparator());
	menuOutils.add(pas             );
	menuOutils.add(new JSeparator());
	menuOutils.add(specSource      );
	menuOutils.add(specPuit        );
	
	menuAide.add(aide   );
	menuAide.add(aPropos);
	
	// Ajout des intituls menus
	menuBarEditeur.add(menuOutils );
	menuBarEditeur.add(menuAide   );
	
	
	// Ajout des vnements
	nouveauSommet.addActionListener(this);
	nouveauArc.addActionListener(this);
	supprimer.addActionListener(this);
	pas.addActionListener(this);
	specSource.addActionListener(this);
	specPuit.addActionListener(this);
	
	
	
	aide.addActionListener(this);
	aPropos.addActionListener(this);
	
	
	// Ajout de la barre des menus
	this.setJMenuBar(menuBarEditeur);
    }
    
    
    public void maj() {
	contenu.creationGrapheGraph(graphe);
    }
    
    
    
    // ----------------------------
    // Gestion des vnements menus
    // ----------------------------
    public void actionPerformed(ActionEvent e) {
	
	/* // 1. Enregistrer
	//------------------
	
	if (e.getSource() == enregistrer) {
	graphe.printConsole();      
	// Insrer code
	}
	
	
	
	// 2. Quitter
	//------------------
	
	if (e.getSource() == quitter)
	{
	System.exit(0);
	}
	*/	
	
	// 1. Nouveau Sommet
	//--------------------
	
	if (e.getSource() == nouveauSommet) {
	    
	    // Tunning de curseur
	    contenu.setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
	    
	    // Ajout du listener
	    contenu.addMouseListener(new MouseAdapter() {
		    public void mouseClicked(MouseEvent me) {
			int locX,locY;
			Sommet tmpSommet;
			contenu.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			locX=(new Integer(me.getX()/contenu.getPas()).intValue());
			locY=(new Integer(me.getY()/contenu.getPas()).intValue());
			if(!contenu.sommetPresent(new Point(locX, locY))) {
			    tmpSommet=graphe.ajouterSommet(locX,locY);
			    contenu.ajouterSommetAFF(tmpSommet);
			    contenu.repaint();
			}
			contenu.removeMouseListener(this);
		    }
		});
	}
	
	
	// 2. Nouvel Arc
	//---------------
	
	if (e.getSource() == nouveauArc) {
	    
	    
	    // Le MouseListener...(bourrin je sais)
	    class obtenirOriginesArc extends MouseAdapter {
		boolean estLOrigine;
		FenEditeur parent;
		int locXSource = 0;
		int locYSource = 0;
		int locXDestin = 0;
		int locYDestin = 0;
		int capacite   = 0;
		public obtenirOriginesArc(FenEditeur parent) {
		    this.estLOrigine = true;
		    this.parent = parent;
		    Image im1  = new ImageIcon("sommetInit.gif").getImage();
		    Toolkit tk = getToolkit();
		    Cursor Custom_Cursor   = tk.createCustomCursor(im1,new Point(0,0),"test");
		    contenu.setCursor(Custom_Cursor);
		}
		
		public void mouseClicked(MouseEvent me) {
		    Image im2  = new ImageIcon("sommetTerm.gif").getImage();
		    Toolkit tk = getToolkit();
		    Cursor Custom_Cursor2  = tk.createCustomCursor(im2,new Point(0,0),"test");
		    Arc arc;
		    
		    // Sommet initial
		    if(estLOrigine) {
			locXSource = (new Integer((me.getX()+contenu.getPas()/2)/contenu.getPas()).intValue());
			locYSource = (new Integer((me.getY()+contenu.getPas()/2)/contenu.getPas()).intValue());
			estLOrigine = false;
			contenu.setCursor(Custom_Cursor2);;
		    }
		    
		    
		    // Sommet terminal
		    else {
			locXDestin = (new Integer((me.getX()+contenu.getPas()/2)/contenu.getPas()).intValue());
			locYDestin = (new Integer((me.getY()+contenu.getPas()/2)/contenu.getPas()).intValue());
			estLOrigine = true;
			contenu.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			
			
			// Capacit
			Object reponses = JOptionPane.showInputDialog(
								      parent,
								      "Entrez la valeur du flot",
								      "Nouvel Arc",
								      JOptionPane.QUESTION_MESSAGE);
			
			try {
			    capacite = (new Integer((String)reponses)).intValue();
			}
			catch(NumberFormatException nfe) {
			    System.out.println("erreur");
			}
			
			
			// et on ajoute l'arc...
			if(capacite!=0) {
			    arc = contenu.ajouterArc(new Point(locXSource, locYSource), new Point(locXDestin, locYDestin),capacite);
			    
			    if(arc!=null) {
				graphe.ajouterArc(arc);
			    }
			}
			contenu.repaint();
			contenu.removeMouseListener(this);
		    }
		    
		}
	    }
	    
	    
	    
	    // Le mouse listener s'auto supprime  la fin 
	    contenu.addMouseListener(new obtenirOriginesArc(this));
	}
	
	
	
	
	// 3. Supprimer
	//--------------
	
	if (e.getSource() == supprimer) {
	    
	    // Tunning de curseur
	    contenu.setCursor(new Cursor(Cursor.HAND_CURSOR));
	    
	    // Ajout du listener
	    contenu.addMouseListener(new MouseAdapter() {
		    public void mouseClicked(MouseEvent me) {
			int locX,locY;
			SommetAFF sommetAFFAEffacer;
			contenu.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			locX=(new Integer(((me.getX()+contenu.getPas()/2))/contenu.getPas()).intValue());
			locY=(new Integer(((me.getY()+contenu.getPas()/2))/contenu.getPas()).intValue());
			if((sommetAFFAEffacer = contenu.obtenirSommetAFFDApresPosition(new Point(locX, locY))) != null) {
			    Sommet sommetAEffacer = sommetAFFAEffacer.getSommet();
			    LinkedList listeSommetAFF = contenu.supprimerSommetAFF(sommetAFFAEffacer);
			    
			    // suppression des arcs adjacents
			    int taille = listeSommetAFF.size();
			    Arc arcTmp;

			    for(int i = 0; i < taille; i++) {
				arcTmp = ((ArcAFF)listeSommetAFF.get(i)).getArc();
				//sommetAEffacer.enleverArc(arcTmp);
				graphe.enleverArc(arcTmp);
				//System.out.println(" arc enleve : "+i);
			    }

			    if(sommetAEffacer==graphe.getSource())
				{graphe.setSource(null);}
			    if(sommetAEffacer==graphe.getPuit())
				{graphe.setPuit(null);}
			    graphe.enleverSommet(sommetAEffacer);
			    //graphe.printConsole();
			}	
			
			contenu.repaint();
			contenu.removeMouseListener(this);
		    }
		});
	}
	
	// 4. Pas
	//--------------
	
	if (e.getSource() == pas) {	
	    // pas
	    int valeurPas = 0;
	    Object pasActuel = (new Integer(contenu.getPas())).toString();
	    Object[] valeursPossibles = {"50", "60", "70","80", "90", "100"};
	    Object reponses = JOptionPane.showInputDialog(
							  this,
							  "Entrez la valeur du nouveau pas",
							  "Nouvel Pas",
							  JOptionPane.QUESTION_MESSAGE,
							  null,
							  valeursPossibles,
							  pasActuel);
	    
	    try {
		valeurPas = (new Integer((String)reponses)).intValue();
	    }
	    
	    catch(NumberFormatException nfe) {
		System.out.println("erreur");
	    }
	    
	    
	    // et on ajoute l'arc...
	    if(valeurPas!=0) {
		contenu.setPas(valeurPas);
	    }
	    
	    contenu.repaint();	
	}
	




	
	// 5.specSource
	// l'utilisateur clique sur le sommet source
	//-------------
	if (e.getSource() == specSource) {

	    // Tunning de curseur
	    contenu.setCursor(new Cursor(Cursor.HAND_CURSOR));
	    
	    // Ajout du listener
	    contenu.addMouseListener(new MouseAdapter() {
		    public void mouseClicked(MouseEvent me) {
			int locX,locY;
			SommetAFF sommetAFFSource;
			contenu.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			locX=(new Integer(((me.getX()+contenu.getPas()/2))/contenu.getPas()).intValue());
			locY=(new Integer(((me.getY()+contenu.getPas()/2))/contenu.getPas()).intValue());
			if((sommetAFFSource = contenu.obtenirSommetAFFDApresPosition(new Point(locX, locY))) != null) {
			    Sommet sommetSource = sommetAFFSource.getSommet();

			    // definition de la nouvelle source
			    graphe.setSource(sommetSource);
			}	
			contenu.removeMouseListener(this);
		    }
		});


	}
	


	//6. specPuit
	// l'utilisateur clique sur le sommet puit
	//-------------
	if (e.getSource() == specPuit) {

 // Tunning de curseur
	    contenu.setCursor(new Cursor(Cursor.HAND_CURSOR));
	    
	    // Ajout du listener
	    contenu.addMouseListener(new MouseAdapter() {
		    public void mouseClicked(MouseEvent me) {
			int locX,locY;
			SommetAFF sommetAFFPuit;
			contenu.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			locX=(new Integer(((me.getX()+contenu.getPas()/2))/contenu.getPas()).intValue());
			locY=(new Integer(((me.getY()+contenu.getPas()/2))/contenu.getPas()).intValue());
			if((sommetAFFPuit = contenu.obtenirSommetAFFDApresPosition(new Point(locX, locY))) != null) {
			    Sommet sommetPuit = sommetAFFPuit.getSommet();

			    // definition de la nouvelle source
			    graphe.setPuit(sommetPuit);
			}	
			contenu.removeMouseListener(this);
		    }
		});



	}
	
	// 7. Aide
	//-------------
	
	if (e.getSource() == aide) {
	    
	    JOptionPane.showMessageDialog(			      this,
								      "Utilisez le menu Outils pour modifier\nvotre graphe a volonte\n",
								      "Aide de l'editeur",  
								      JOptionPane.PLAIN_MESSAGE
								      
								      
								      );
	    
	}
	
	
	// 8. A propos
	//--------------
	
	if (e.getSource() == aPropos) {
	    
	    JOptionPane.showMessageDialog(			      this,
								      "Cet editeur graphique vous est propose par \n Maxime Chambreui, Nicolas Fournel, Vianney Gremmel, Leila Traore et Marouane Zehni.\n @ INSA de Rouen, janvier 2003",
								      "Editeur Graphique pour Ford-Fulkerson",  
								      JOptionPane.PLAIN_MESSAGE
								      
								      
								      );   
	}
    }    
}








//-----------------------------
//  Le contenu de la fentre 
//-----------------------------
class FenConEditeur extends JPanel {
    
    // Le Graphe  afficher
    private Graphe gr;
    
    // La liste des Sommets et des arcs
    private LinkedList listeSommetAFF = new LinkedList();
    private LinkedList listeArcAFF = new LinkedList();
    private LinkedList listePosition = new LinkedList();
    
    private int pas;
    
    // ------------
    // Constructeur
    // ------------
    public FenConEditeur(Graphe gra) {
	
	this.creationGrapheGraph(gra);
	pas=50;
	
    }
    
    // ----------------
    // Dessin du graphe
    // ----------------
    public void paintComponent(Graphics g) {
	
	super.paintComponent(g);
        
	SommetAFF sommetCourant;
	ArcAFF arcCourant;
	int i,taille,ix,iy,tailleFenX,tailleFenY,maxI,maxJ;
	
	// Affichage de la grille
	
	tailleFenY=(int)(new Double(this.getSize().getHeight()).intValue());
	tailleFenX=(int)(new Double(this.getSize().getWidth()).intValue());
	
	maxI=(new Integer(tailleFenX/pas).intValue());
	maxJ=(new Integer(tailleFenY/pas).intValue());
	
	for(ix=1;ix<=maxI;ix++)
	    {
		for(iy=1;iy<=maxJ;iy++)
		    {
			g.setColor(Color.black);
			g.fillOval(ix*pas,iy*pas,3,3);
		    }
	    }
	
	// Affichage du Graphe Courant ...
	
	taille=listeArcAFF.size();
	for(i=0;i<taille;i++)
	    {
		arcCourant=(ArcAFF)listeArcAFF.get(i);
		arcCourant.dessiner(g, pas, pas);
	    }
	
	taille=listeSommetAFF.size();
        for(i=0;i<taille;i++)
	    {
		sommetCourant=(SommetAFF)listeSommetAFF.get(i);
		sommetCourant.dessiner(g,pas,pas);
	    }
	
    }
    
    // ----------------------------------------------------------------------------
    // Cration du graphe graphique d'apres le graphe logique (j'espere etre clair)
    // ----------------------------------------------------------------------------
    public void creationGrapheGraph(Graphe gra) {
	int i, taille;
	LinkedList tmpList = new LinkedList();
	SommetAFF sommAffCourant;
	ArcAFF arcAffCourant;
	Point position = new Point();
	listeSommetAFF.clear();
	listeArcAFF.clear();
	listePosition.clear();
	tmpList.addAll(gra.getListeSommet());
	taille=tmpList.size();
	
	// Ajout des sommets
	for(i=0;i<taille;i++) {
	    sommAffCourant=new SommetAFF((Sommet)tmpList.get(i),false);
	    position = sommAffCourant.getPosition();
	    listeSommetAFF.add(sommAffCourant);
	    listePosition.add(position);
	}
	tmpList.clear();
	tmpList.addAll(gra.getListeArc());
	taille=tmpList.size();
	for(i=0;i<taille;i++) {
	    arcAffCourant=new ArcAFF((Arc)tmpList.get(i),false);
	    arcAffCourant.setPInit(new Point(
					     ((Arc)tmpList.get(i)).getInitial().getX(),
					     ((Arc)tmpList.get(i)).getInitial().getY()
					     ));
	    arcAffCourant.setPTerm(new Point(
					     ((Arc)tmpList.get(i)).getTerminal().getX(),
					     ((Arc)tmpList.get(i)).getTerminal().getY()
					     ));
	    
	    listeArcAFF.add(arcAffCourant);
	}
	
    }
    
    // ----------------------------------------------------
    // Ajout d'un sommet graphique avec un sommet en entree
    // ----------------------------------------------------
    void ajouterSommetAFF(Sommet s) {
	//Cration du nouveau sommetAFF
	SommetAFF newSommetAFF = new SommetAFF(s);
	
	// on vrifie qu'il n'y a pas dj un sommet existant  cette place
	if(this.estMalPlace(newSommetAFF)) {
	    System.out.println("Sommet deja existant ici");
	}
	else {
	    //Ajout du sommet au graphe
	    this.listeSommetAFF.add(newSommetAFF);
	    this.listePosition.add(newSommetAFF.getPosition());
	    
	}
	
    }
    
    // ---------------------------------------------------------------------------------------
    // indique si le nouveau sommet est mal plac (prsence d'un ancien sommet au meme endroit)
    // ---------------------------------------------------------------------------------------
    
    boolean estMalPlace(SommetAFF s) {
	// renvoie vrai si le sommet est mal plac
	return(this.sommetPresent(s.getPosition()));
	
    }
    
    
    
    // -------------------------------------------------------
    // indique si un sommet est prsent au point p
    // -------------------------------------------------------
    boolean sommetPresent(Point p) {
	// renvoie vrai si un sommet est prsent  cette place
	if(this.listePosition.contains(p)) {
	    return true;
	}
	else {
	    return false;
	}
    }
    
    
    // ----------------------------------------------------------------
    // retourne le SommetAFF prsent au point p, null s'il n'y en a pas
    // ----------------------------------------------------------------
    SommetAFF obtenirSommetAFFDApresPosition(Point position) {
	// renvoie le sommet d'apres une position
	if(!sommetPresent(position)) {
	    return null;
	}
	else {
	    int i = this.listePosition.indexOf(position);
	    return (SommetAFF)this.listeSommetAFF.get(i);
	}
    }
    
    
    //---------------------------
    // suppression d'un sommetAFF
    //---------------------------
    
    LinkedList supprimerSommetAFF(SommetAFF sommetAFF) {
	// suppression des arcs adjacents
	int taille = listeArcAFF.size();
	LinkedList tmpListe = new LinkedList();
	for(int i = 0;i < taille;i++) {
	    if (
		((ArcAFF)listeArcAFF.get(i)).getPTerm().equals(sommetAFF.getPosition())
		||
		((ArcAFF)listeArcAFF.get(i)).getPInit().equals(sommetAFF.getPosition())
		) {
		tmpListe.add((ArcAFF)listeArcAFF.get(i));
		
	    }
	}
	taille = tmpListe.size();
	for(int i = 0; i < taille;i++) { 
	    this.supprimerArcAFF((ArcAFF)tmpListe.get(i));
	}
	this.listeSommetAFF.remove(sommetAFF);
	this.listePosition.remove(sommetAFF.getPosition());
	return tmpListe;
    }
    
    
    
    
    //------------------------
    // suppression d'un arcAFF
    //------------------------
    
    void supprimerArcAFF(ArcAFF arcAFF) {
   	this.listeArcAFF.remove(arcAFF);
    }
    
    
    
    //---------------------------------------------------
    // ajout d'un arc d'apres sa source et sa destination
    //---------------------------------------------------
    
    
    Arc ajouterArc(int source, int destination, int capacite) {
	//Cration du nouvel arc
	Arc arc;
	
	//System.out.println("dimension de la liste : "+listeSommetAFF.size());
	//System.out.println("source - 1 = "+ (source-1) );

	SommetAFF temp1   = (SommetAFF)listeSommetAFF.get(source-1);

	//System.out.println("destination - 1 : "+ (destination-1) );
	Sommet sommetInit = temp1.getSommet();
	SommetAFF temp2   = (SommetAFF)listeSommetAFF.get(destination-1);
	Sommet sommetTerm = temp2.getSommet();
	ArcAFF newArcAFF  = new ArcAFF(arc = new Arc(sommetInit, sommetTerm, capacite));
	newArcAFF.setPInit((Point)listePosition.get(source-1));
	newArcAFF.setPTerm((Point)listePosition.get(destination-1));
	// Ajout au graphe
	this.listeArcAFF.add(newArcAFF);	
	
	return arc;
	
    }
  
    
    //-------------------------------------
    // ajout d'un arc d'apres ses positions
    //-------------------------------------
    
    Arc ajouterArc(Point posSource, Point posDestin, int capacite) {
	Arc arc;
	if(!this.sommetPresent(posSource) || !this.sommetPresent(posDestin)) {
	    return null;
	}
	else {
	    arc = ajouterArc(this.listePosition.indexOf(posSource)+1, this.listePosition.indexOf(posDestin)+1, capacite);
	    
	}
	return arc;
    }
    
    
    
    LinkedList getListeSommetAFF() {
	return listeSommetAFF;
    }
    
    
    LinkedList getListeArcAFF() {
	return listeArcAFF;
    }
    
    LinkedList getListePosition() {
	return listePosition;
    }
    
    
    void setPas(int a) {
	pas=a;
    }
    
    int getPas() {
	return pas;
    }
    
    
}
