//package code2001b;

import java.util.LinkedList;
import java.util.List;

//import code2001b.Arc;

/**
 * @author 
 */
 
//-------------------------------------------------//
//                                                 //
//                CLASSE SOMMET                    //
//                                                 //
//-------------------------------------------------//


public class Sommet {

  // Caracteristiques de base d'un graphe
  private String name;
  private int id;
  private LinkedList listSucc;
  private LinkedList listPred;
  
  private boolean marque;
  private int delta;
  private Arc provenance;
  private boolean deltaNegatif;

  private int positionX;
  private int positionY;
  private int etat;

  //---------------------------------------
  // Etat du Sommet
  // 
  // 0 : Rien
  // 1 : Marke
  // 2 : En cours de traitement
  // 3 : Traite
  //
  //---------------------------------------


 
  /*
  public Sommet(int numero) {
    id = numero;
    listSucc = new LinkedList();
    listPred = new LinkedList();
    delta=-1;
    marque=false;
    positionX = 2;
    positionY = 2;
  }
  */
 
  //---------------------------------------------------
  // Constructeur:
  // C dans le nom ...
  //---------------------------------------------------

  public Sommet(int numero, int x, int y) {
    id = numero;
    listSucc = new LinkedList();
    listPred = new LinkedList();
    delta = -1;
    marque = false;
    positionX = x;
    positionY = y;
    etat=0;
    deltaNegatif=false;
    provenance=null;
 } 
 
  //---------------------------------------------------
  // Fonction getId():
  // Recupere l'Id du Sommet
  //---------------------------------------------------
  
  public int getId() {
    return id;
  }

  //---------------------------------------------------
  // Fonction getName():
  // Recupere le Nom du Sommet
  //---------------------------------------------------
  
  public String getName() {
    return name;
  }

  //---------------------------------------------------
  // Fonction getX(), setX():
  // Permet de manipuler le X du Sommet
  //---------------------------------------------------
   
  public int getX() {
    return positionX;
  }

  public void setX(int x) {
    positionX = x;
  }

  //---------------------------------------------------
  // Fonction getY(), setY():
  // Permet de manipuler le Y du Sommet
  //---------------------------------------------------

  public int getY() {
    return positionY;
  }

  public void setY(int y) {
    positionY = y;
  }

  //---------------------------------------------------
  // Fonction getDelta(), setDelta():
  // Permet de Recuperer et Fixer delta du Sommet
  //---------------------------------------------------

  public int getDelta() {
    return delta;
  }

  public void setDelta(int a) {
    delta=a;
  }
  
  //---------------------------------------------------
  // Fonction estMarque():
  // Permet de savoir si le Sommet est marque
  //---------------------------------------------------

  public boolean estMarque() {
    return marque;
  }

  //---------------------------------------------------
  // Fonction marquer(), demarquer():
  // Permettent de marquer et demarquer un sommet
  //---------------------------------------------------
 
  public void marquer() {
    setEtat(1);
    marque=true;
  }
  
  public void demarquer() {
    marque=false;
    delta=-1;
    setEtat(0);
  }

  //---------------------------------------------------
  // Fonction getEtat(), setEtat():
  // Permet de manipuler l'etat du sommet
  //---------------------------------------------------

  public int getEtat() {
    return etat;
  }

  public void setEtat(int a) {
    etat=a;
  }

  //---------------------------------------------------
  // Fonction estUnDeltaNegatif():
  // Permet de savoir si le delta est negatif
  //---------------------------------------------------

  public boolean estUnDeltaNegatif() {
    return deltaNegatif;
  }

  //---------------------------------------------------
  // Fonction fixerProvenance(), obtenirProvenance():
  // Permet de manipuler la provenance pour l'algo de markage
  //---------------------------------------------------

  public void fixerProvenance(Arc a,boolean neg) {
    provenance=a;
    deltaNegatif=neg;
  }

  public Arc obtenirProvenance() {
    return provenance;
  }
 
  //---------------------------------------------------
  // Fonction ajouterEntrant()(respectivement ajouterSortant()):
  // Permet d'ajouter un arc  la liste des Arcs entrant (respectivement sortant)
  //---------------------------------------------------
 
  public void ajouterEntrant(Arc arc) {
    listPred.add(arc);
  }

  public void ajouterSortant(Arc arc) {
    listSucc.add(arc);
  }
 
  //---------------------------------------------------
  // Fonction obtenirEntrant()(respectivement obtenirSortant()):
  // Permet d'obtenir la liste des Arcs entrant (respectivement sortant)
  //---------------------------------------------------

  public List obtenirEntrant() {
    return listPred;
  }
  	
  public List obtenirSortant() {
    return listSucc;
  }
 
  //---------------------------------------------------
  // Fonction enleverEntrant()(respectivement enleverSortant()):
  // Permet d'enlever un arc de la liste des Arcs entrant (respectivement sortant)
  //---------------------------------------------------
 
  public void enleverEntrant (Arc arc) {
    listPred.remove(arc);
  }

  public void enleverSortant (Arc arc) {
    listSucc.remove(arc);
  }

    //---------------------------------
    // Enlever un arc qqconque
    //---------------------------------


    public void enleverArc(Arc arc) {
	if(listPred.contains(arc)) {
	    enleverEntrant(arc);
	}
	if(listSucc.contains(arc)) {
	    enleverSortant(arc);
	}
    }


  //---------------------------------------------------
  // Fonction deleteSommet():
  // Permet de supprimer le Sommet
  //---------------------------------------------------


  public void deleteSommet() throws Throwable {
    for(int i=0; i < listSucc.size();i++){
      Arc tmp;
      tmp=(Arc)listSucc.getFirst();
      tmp.deleteArc();
      
    }
    for(int i=0; i < listPred.size();i++){
      Arc tmp;
      tmp=(Arc)listPred.getFirst();
      tmp.deleteArc();
    }
    this.finalize();
  }
}
