//package code2001b;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;

/**
 * @author = Maxime Chambreuil 
 */

//-------------------------------------------------//
//                                                 //
//                CLASSE SOMMETAFF                 //
//                                                 //
//-------------------------------------------------//
 
public class SommetAFF extends JComponent implements MouseListener, MouseMotionListener{

  private static int rayon = 15;
  private Sommet sommet;
  private Color couleur;
    private boolean useViewer;
  
  
  //---------------------------------------------------
  // Constructeur:
  // C dans le nom ...
  //---------------------------------------------------
 
  public SommetAFF(Sommet s,boolean b) {
    sommet=s;
    useViewer=b;
  }
  public SommetAFF(Sommet s) {
    sommet=s;
    useViewer=false;
  }
  //---------------------------------------------------
  // Fonction getSommet():
  // Permet de recuperer le Sommet du SommetAFF
  //---------------------------------------------------
  
  public Sommet getSommet() {
    return sommet;
  }

  //---------------------------------------------------
  // Fonction getPosition():
  // Permet de recuperer la position du Sommet
  //---------------------------------------------------

  public Point getPosition() {
    Point tmp=new Point(sommet.getX(),sommet.getY());
    return tmp;
  }
  
  //---------------------------------------------------
  // Fonction setPosition():
  // Permet de fixer la position du Sommet
  //---------------------------------------------------
  
  public void setPosition(int positionX, int positionY) {
    sommet.setX(positionX);
    sommet.setY(positionY);
  }

  //---------------------------------------------------
  // Fonction setRayon():
  // Permet de fixer le Rayon du Sommet
  //---------------------------------------------------
  
  
  public void setRayon(int ray) {
    rayon = ray;
    }

  public static int getRayon() {
    return rayon;
  }
  
  //---------------------------------------------------
  // Fonction dessiner():
  // Permet de dessiner le Sommet
  //---------------------------------------------------

  public void dessiner(Graphics g,int pasX, int pasY) {	

    FontMetrics fm = g.getFontMetrics();

    // Couleur de remplissage du cercle
    setCouleur();
    g.setColor(couleur);
 
   // Trac du cercle
    g.fillOval(sommet.getX()*pasX-rayon,sommet.getY()*pasY-rayon,2*rayon,2*rayon);
    
    // Couleur de la police
    g.setColor(Color.black);
    // Dessin de la police
    g.drawString(Integer.toString(sommet.getId()),sommet.getX()*pasX,sommet.getY()*pasY);
    // Trac du contour
    g.drawOval(sommet.getX()*pasX-rayon,sommet.getY()*pasY-rayon,2*rayon,2*rayon);

    if(sommet.getEtat()>=1 && sommet.obtenirProvenance()!=null && useViewer){
	String lbl;
	if(sommet.estUnDeltaNegatif())
	    {
		lbl="-"+Integer.toString(sommet.getDelta())+" <-- "+Integer.toString(sommet.obtenirProvenance().getTerminal().getId());;
	    }
	else
	    {
		lbl=Integer.toString(sommet.getDelta())+" <-- "+Integer.toString(sommet.obtenirProvenance().getInitial().getId());
	    }
	int haut=fm.getHeight()+1;
	int larg=fm.stringWidth(lbl) + 10;

      g.setColor(Color.white);
      g.fillRect(sommet.getX()*pasX - larg/2 , sommet.getY()*pasY+20 - haut/2 , larg ,haut);
      // Dessin de la police
      g.setColor(Color.black);
      //g.drawRect(sommet.getX()*pasX - larg/2 , sommet.getY()*pasY+20 - haut/2 , larg  ,haut);
      g.drawString(lbl,sommet.getX()*pasX-(larg-10)/2,(sommet.getY()*pasY+20-(haut-1)/2) + fm.getAscent());
     }
  }
  
  //---------------------------------------------------
  // Fonction setCouleur():
  // Permet de definir la couleur de le SommetAFF en fonction de l'Etat
  //---------------------------------------------------

  public void setCouleur() {
    int etat=0;
    if(useViewer){
	etat=sommet.getEtat();
    }
    switch(etat) {
      
    case 0: //Rien
      couleur=Color.green;
      break;
    case 1: //Marke
      couleur=Color.orange;
      break;
    case 2: //Actif (Markage)
      couleur=Color.red;
      break;
    case 3: //Scanne
      couleur=Color.pink;
      break;
    default:
      couleur=Color.white;
    }
  }

   // les vnements

    	public void mouseClicked(MouseEvent e) {
	    //Invoqu quand la souris clique sur le sommet
	} 

	public void mousePressed(MouseEvent e) {}
	//Invoqu quand la souris reste appuye sur le sommet

	public void mouseReleased(MouseEvent e) {}
	//Invoqu quand on lche le bouton de la souris sur le sommet

	public void mouseEntered(MouseEvent e) {}
	//Invoqu quand la souris entre dans le sommet

	public void mouseExited(MouseEvent e) {}
	//Invoqu quand la souris sort du sommet


	public void mouseDragged(MouseEvent e) {
	 //vrifier que la souris est dans la zone
	    // if (contains(e.getX(),e.getY())) {
	    System.out.println("vnement souris Sommet !!");
	  sommet.setX(e.getX());
	  sommet.setY(e.getY());
	  repaint();
	  // } 
	}

	public void mouseMoved(MouseEvent e) {}


//--------------------------------------------------------------//
//                                                              //
//                   Fin de la CLASSE				//
//                                                              //
//--------------------------------------------------------------//

  
}
